/** 
 *  provides a static method to calculate the gcd
 *  accordning to the Euclidean algorith
 */

public class Gcd {

	public static int gcd(int x, int y) {
		// Handle special case
		if (x == 0) {
			return y;
		}
		if (y == 0) {
			return x;
		}

		// Prevent endless loop
		if (x < 0) {
			x = -x;
		}
		if (y < 0) {
			y = -y;
		}

		// Euclidean algorithm
		while (x != y) {
			if (x > y) {
				x = x - y;
			}
			else {
				y = y - x;
			}
		}

		return x;
	}
}
